/*************************************************************************/
/*
 *  Datei           : JAUFILE.CC
 *  Inhalt          : FileSize
 *                    JauRename
 *  Programmierer   : Sven Goethel
 *					  Stapenhorststr.35a
 *					  33615 Bielefeld
 *					  0521/139228
 *  Erstellungsdatum: 04.11.1994
 *  nderungsdatum  :
 *  Projekt         : fkontur
 *  Verzeichnis     :
 *  Dokumentation   : fcont.doc
 *
 *  $Log: jaufile.cc $
 *  Revision 1.4  1995/04/07 16:54:49  Sven_Goethel_DFP
 *  *** empty log message ***
 *  Revision 1.3  1995/04/04 10:37:24  Sven_Goethel
 *  *** empty log message ***
 *  Revision 1.2  1994/12/15 15:28:01  Sven_Goethel
 *  the very first check in !!!
 *  all files contains the log message now !!!
 *  Sven Goethel, Bielefeld 14.12.1994 !!!
 *  
 *  Revision 1.1  1994/12/15 15:18:38  Sven_Goethel
 *  Initial revision
 *
 *    (C) Copyright Dr.-Ing.F.Prekwinkel GmbH, 32052 Herford, Germany
 */
/*************************************************************************/


#include "jaufile.h"

/*DOCST------------------------------------------------------------------------------

	File-Groesse holen
	------------------------------------
	size_t FileSize(FILE *stream)

	- Beschreibung
	--------------
	Returniert die File-Groesse !!!


	- Parameter
	-----------
	FILE * stream

	- allgemeine Ein- und Ausgabeeinheiten
	--------------------------------------

	- Returncode
	------------
	>= 0 	File-Groesse
	<0 		Error

	- Historie
	----------
	04.11.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
size_t FileSize(FILE *stream)
{
   if(stream==NULL) return -1;

   long curpos, length;

   curpos = ftell(stream);
   fseek(stream, 0L, SEEK_END);
   length = ftell(stream);
   fseek(stream, curpos, SEEK_SET);

   if(length>((size_t)(~0)))
	 length=((size_t)(~0)) ;

   return (size_t)length;
}


/*DOCST------------------------------------------------------------------------------

	ndert den Namen einer Datei
	------------------------------------
	Definition:  int JauRename(const char *oldname, const char *newname);

	- Beschreibung
	--------------
	imos_rename ndert den Namen einer Datei von oldname auf newname,
	im Netzbetrieb.
	Dazu wird voher versucht ein passender File-Buffer zu erhalten !!!


	- Parameter
	-----------
	E:
		*oldname	= alter Name
		*newname    = neuer Name

	- allgemeine Ein- und Ausgabeeinheiten
	--------------------------------------

	- Returncode
	------------
	1 - OK
	0 - FEHLER

	- Historie
	----------
	04.11.1994 Sven Goethel

------------------------------------------------------------------------------DOCEND*/
int JauRename(const char *oldname, const char *newname)
{
	FILE *in=NULL, *out=NULL;

	if ((in = fopen(oldname, "rb")) == NULL)
		return 0;

	// BufferSize setzen !!!
	size_t Len=FileSize(in);
	size_t len;


	for(len=Len;;) // forever
	{
	  if (setvbuf(in, NULL, _IOFBF, len) == 0) break;
	  else
	  {
		if(len==BUFSIZ) INT_ERR(__LINE__);
		len-=len/4;
		if(len<BUFSIZ) len=BUFSIZ;
	  }
	}

	if ((out = fopen(newname, "w+b")) == NULL) {
		fclose(in);
		return 0;
	}

	for(len=Len;;) // forever
	{
	  if (setvbuf(out, NULL, _IOFBF, len) == 0) break;
	  else
	  {
		if(len==BUFSIZ) INT_ERR(__LINE__);
		len-=len/4;
		if(len<BUFSIZ) len=BUFSIZ;
	  }
	}

	while (!feof(in))
	{
		char c=fgetc(in);
		if(c>=0) fputc(c, out);
	}

	fclose(in);
	fclose(out);
	remove(oldname);
	return 1;
}
